<template>
  <div class="questionnaire">
    <div class="questionnaire__title" v-text="questionTitle"></div>
    <div
      :key="i"
      class="questionnaire__main"
      v-for="(question, i) in questions"
    >
      <div class="questionnaire__question" v-show="currentQuestion == i + 1">
        <div class="questionnaire__answers" v-if="question.type == 'radio'">
          <RadioComponent
            :key="key"
            :value="answer"
            :name="question.question"
            class="questionnaire__radio"
            v-for="(answer, key) in question.answers"
            v-on:handle-change="$emit('handle-change', $event)"
          />
        </div>
        <div class="questionnaire__answers" v-if="question.type == 'textarea'">
          <TextareaComponent
            :disabled="question.value == 'off'"
            :value="question.value"
            v-on:handle-input="$emit('handle-input', $event)"
            class="questionnaire__textarea"
          />
          <CheckboxComponent
            :value="question.value"
            name="I do not want to answer"
            v-on:handle-change="$emit('handle-change', $event)"
            class="questionnaire__check"
          />
        </div>
        <div class="questionnaire__answers" v-if="question.type == 'checkbox'">
          <CheckboxComponent
            :key="key"
            :value="answer"
            :name="answer"
            class="questionnaire__check"
            v-for="(answer, key) in question.answers"
            v-on:handle-change="$emit('handle-change', $event)"
          />
          <TextareaComponent
            :disabled="question.value.indexOf('Your answer') == -1"
            :value="question.comment"
            v-on:handle-input="$emit('handle-input', $event)"
            class="questionnaire__textarea"
          />
        </div>
      </div>
    </div>
    <div class="questionnaire__action">
      <button @click="$emit('handle-click')" class="btn">Next</button>
    </div>
  </div>
</template>
<script>
import RadioComponent from "@/components/RadioComponent";
import CheckboxComponent from "@/components/CheckboxComponent";
import TextareaComponent from "@/components/TextareaComponent";

export default {
  name: "Questionnaire",
  props: {
    questions: {
      type: Array,
      default: [],
    },
    currentQuestion: {
      type: Number,
      default: 1,
    },
  },
  emits: ["handle-change", "handle-click", "handleInput"],
  components: {
    RadioComponent,
    CheckboxComponent,
    TextareaComponent,
  },
  computed: {
    questionTitle() {
      const text = `${this.questions[this.currentQuestion - 1].question} (${
        this.currentQuestion
      }/${this.questions.length})`;

      return text;
    },
  },
};
</script>
<style lang="scss">
.questionnaire__title {
  font-size: 15px;
  line-height: 30px;
  margin-bottom: 30px;
  font-weight: 500;
}
.questionnaire__radio,
.questionnaire__check,
.questionnaire__textarea {
  margin-bottom: 12px;
}
.questionnaire__main {
  margin-bottom: 28px;
}
.btn {
  background: #4bbdfd;
  border-radius: 5px;
  padding: 10px 20px;
  font-weight: 700;
  font-size: 14px;
  line-height: 18px;
  color: #fff;
  border: none;
  width: 133px;
  cursor: pointer;
  outline: none;
  box-sizing: border-box;
  &:hover {
    background: darken(#4bbdfd, 10%);
  }
  &:focus {
    outline: none;
  }
}
</style>